﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace UltraTreeProblem
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }
        public Form2(string key)
        {
            Key = key;
            InitializeComponent();            
            var rootNode = new UltraTreeNode("root", "Long root name");
            rootNode.Nodes.AddRange(new UltraTreeNode[]
            {                
                new UltraTreeNode("child1", "A long child name"),
                new UltraTreeNode("child2", "Another long child name"),
                new UltraTreeNode("child3", "One more long child name"),
                new UltraTreeNode("child4", "ukykbgfgbfggb"),
                new UltraTreeNode("child5", "qsqwsqwedeffffef"),
                new UltraTreeNode("child6", "A long child name"),
                new UltraTreeNode("child7", "Another long child name"),
                new UltraTreeNode("child8", "One more long child name"),
                new UltraTreeNode("child9", "sdkflskdjflskdjflskjfd"),
                new UltraTreeNode("child10", "iuroeiuroeirkdjfld"),
                new UltraTreeNode("child11", "Short"),
                new UltraTreeNode("child12", "Yet another long child name"),
                new UltraTreeNode("child13", "One more long child name"),
                new UltraTreeNode("child14", "3434645764574576"),
                new UltraTreeNode("child15", "bnbnbnbnvbnvnbvbnvbn")
            });
            rootNode.Expanded = true;
            ultraTree1.Nodes.Add(rootNode);                       
            UltraTreeNode initial = null;
            if (String.IsNullOrWhiteSpace(Key))
                initial = rootNode;
            else
            {
                initial = ultraTree1.GetNodeByKey(Key);
                if (initial == null)
                    initial = rootNode;
            }
            initial.Selected = true;
            // This call causes the problem; seems to be looking at the right edge of the root node's bounds in relation to this node
            // when initially displaying
            initial.BringIntoView();            
            button1.Click += (sender, args) =>
            {
                if (ultraTree1.SelectedNodes.Count > 0)
                    Key = ultraTree1.SelectedNodes[0].Key;
                DialogResult = DialogResult.OK;
                Close();
            }; 
        }

        public string Key { get; private set; }
    }
}
